#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <math.h>

#include <glib.h>
#include <glib/gi18n.h>

#include "xml.h"
#include "page.h"
#include "cb.h"
#include "tag.h"
#include "group.h"
#include "app.h"

gboolean exchange_time_out_cb(gpointer *data)
{
	WPSApp *app = (WPSApp *)data;
	WPSPage *page;
	WPSWidget *widget;
	WPSGroup *group;
	LinkAttribute *link_attr = NULL;
	GList *last_widget = NULL;
	GList *last_group = NULL;
	GList *last_link_attr = NULL;
	Tag *tag = NULL;
	GList *widget_list;
	GList *group_list;
	//gboolean value;
	//gdouble value;
	
	//page = ctx->active_page;
	page = app->current_page;
	widget_list = wps_page_get_widget_list(page);
	group_list = wps_page_get_group_list(page);
	
	//g_warning("exchange: %s\n", page->page_info->name->str);
	for (last_widget = g_list_last(widget_list); last_widget != NULL; last_widget = g_list_previous(last_widget)) {
		widget = last_widget->data;
		//g_warning("widget: %s\n", widget->widget_info->name->str);
		if (widget->link_attributes != NULL) {
			for (last_link_attr = g_list_last(widget->link_attributes); last_link_attr != NULL; last_link_attr = g_list_previous(last_link_attr)) {
				link_attr = last_link_attr->data;
				tag = tag_table_find_tag_by_name(link_attr->tag);
				if (tag != NULL) {
					if (link_attr->direction == DIR_IN) {
						//g_warning("In tag %d", g_value_get_double(tag->value));
						//value = g_value_get_boolean(tag->value);
						g_value_copy(tag->value, link_attr->value);
						/*if (value == FALSE)
							g_warning("in tag FALSE\n");
						else if (value == TRUE)
							g_warning("in tag TRUE\n");*/
						//g_warning("In link attr %d", g_value_get_double(link_attr->value));
						g_signal_emit_by_name(widget, "update_prop", NULL);
						//g_warning("IN============== %s\n", widget->widget_info->name->str);
					}
					else if (link_attr->direction == DIR_OUT) {
						g_value_copy(link_attr->value, tag->value);
						//g_warning("OUT============== %s\n", widget->widget_info->name->str);
					}
					else
						g_warning("Unknown direction\n");
						
				}
			}
		}	
	}
	
	for (last_group = g_list_last(group_list); last_group != NULL; last_group = g_list_previous(last_group)) {
		group = last_group->data;
		//g_warning("group: %s\n", group->group_info->name->str);
		if (group->link_attributes != NULL) {
			for (last_link_attr = g_list_last(group->link_attributes); last_link_attr != NULL; last_link_attr = g_list_previous(last_link_attr)) {
				link_attr = last_link_attr->data;
				tag = tag_table_find_tag_by_name(link_attr->tag);
				if (tag != NULL) {
					if (link_attr->direction == DIR_IN) {
						//g_warning("In tag %d", g_value_get_double(tag->value));
						//value = g_value_get_boolean(tag->value);
						g_value_copy(tag->value, link_attr->value);
						/*if (value == FALSE)
							g_warning("in tag FALSE\n");
						else if (value == TRUE)
							g_warning("in tag TRUE\n");*/
						//g_warning("In link attr %d", g_value_get_double(link_attr->value));
						g_signal_emit_by_name(group, "update_prop", NULL);
						//g_warning("IN============== %s\n", widget->widget_info->name->str);
					}
					else if (link_attr->direction == DIR_OUT) {
						g_value_copy(link_attr->value, tag->value);
						//g_warning("OUT============== %s\n", widget->widget_info->name->str);
					}
					else
						g_warning("Unknown direction\n");
						
				}
			}
		}	
	}
	
	return TRUE;
}

int main(int argc, char **argv)
{
	WPSApp *app;
	GList *page_list;
	ResultInfo *res;
	
	if (argc < 2) {
		printf("So few arguments\n");
		exit(0);
	}
	
	gtk_init(&argc, &argv);
	
	//init_table_handler();
	
	res = parse_xml_file(argv[1]);
	page_list = wps_create_pages_from_info(res->page_info, res->template_info);
	assign_handlers();
	
	app = g_object_new(WPS_TYPE_APP, "page_list", page_list, NULL);
	
	Tag *tag;
	Tag *tag1;
	Tag *tag2;
	Tag *tag3;
	Tag *tag4;
	Tag *tag5;
	gdouble set = 10;
	
	tag = g_new0(Tag, 1);
	tag->name = g_strdup("YELLOW");
	tag->value = g_new0(GValue, 1);
	g_value_init(tag->value, G_TYPE_BOOLEAN);
	g_value_set_boolean(tag->value, FALSE);
	tag_table_insert_value(tag->name, tag);
	
	tag2 = g_new0(Tag, 1);
	tag2->name = g_strdup("GREEN");
	tag2->value = g_new0(GValue, 1);
	g_value_init(tag2->value, G_TYPE_BOOLEAN);
	g_value_set_boolean(tag2->value, FALSE);
	tag_table_insert_value(tag2->name, tag2);
	
	tag3 = g_new0(Tag, 1);
	tag3->name = g_strdup("RED");
	tag3->value = g_new0(GValue, 1);
	g_value_init(tag3->value, G_TYPE_BOOLEAN);
	g_value_set_boolean(tag3->value, FALSE);
	tag_table_insert_value(tag3->name, tag3);
	
	tag4 = g_new0(Tag, 1);
	tag4->name = g_strdup("LENGTH");
	tag4->value = g_new0(GValue, 1);
	g_value_init(tag4->value, G_TYPE_DOUBLE);
	g_value_set_double(tag4->value, 0.0);
	tag_table_insert_value(tag4->name, tag4);
	
	tag5 = g_new0(Tag, 1);
	tag5->name = g_strdup("LENGTH1");
	tag5->value = g_new0(GValue, 1);
	g_value_init(tag5->value, G_TYPE_DOUBLE);
	g_value_set_double(tag5->value, 0.0);
	tag_table_insert_value(tag5->name, tag5);
	
	tag1 = g_new0(Tag, 1);
	tag1->name = g_strdup("SPIN_NUMB");
	tag1->value = g_new0(GValue, 1);
	g_value_init(tag1->value, G_TYPE_DOUBLE);
	g_value_set_double(tag1->value, set);
	tag_table_insert_value(tag1->name, tag1);
		
	gtk_timeout_add(100, (GtkFunction)exchange_time_out_cb, app);
	
	gtk_main();
	
	return 0;
}
